rm(list=ls(all=TRUE))
setwd("H:/idrologia/pluviometria")
list.files()
data=read.table("precipitazioni.txt")
#creazione dei data relativi ai vari intervalli
anni<-data[,1]
anni
data15m<-data[,2]
data15m
data30m<-data[,3]
data30m
data45m<-data[,4]
data45m
data1h<-data[,5]
data1h
data3h<-data[,6]
data3h
data6h<-data[,7]
data6h
data12h<-data[,8]
data12h
data24h<-data[,9]
data24h
#grafica delle precipitazioni per i vari tempi
plot(anni,data12h,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="violet",lwd=2,ylim=range(0,180),main="Massimi di precipitazione")
lines(anni,data24h,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="blue",lwd=2)
lines(anni,data6h,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="green",lwd=2)
lines(anni,data3h,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="orange",lwd=2)
lines(anni,data1h,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="red", lwd=2)
lines(anni,data45m,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="yellow", lwd=2)
lines(anni,data30m,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="dark red", lwd=2)
lines(anni,data15m,xlab="Anni",ylab="Precipitazione[mm]",type="l",col="dark green", lwd=2)
#selezione data elimina NA
data15m <-data15m[!is.na(data15m)]
data30m <-data30m[!is.na(data30m)]
data45m <-data45m[!is.na(data45m)]
data1h <-data1h[!is.na(data1h)]
data3h <-data3h[!is.na(data3h)]
data6h <-data6h[!is.na(data6h)]
data12h <-data12h[!is.na(data12h)]
data24h <-data24h[!is.na(data24h)]
#----------------------------------------------------------------1ora---------------------------------------------------------
#ecdf
ecdf(data1h) -> ecdf1h
x <- seq(from=0,to=max(data1h),by=1)
ecdf1h(x)
#gumbel
library("evd")
#momenti
mean(data1h)->m1h
var(data1h)->var1h
eulergamma <- 0.5772156649
b1hm <- sqrt(6*var1h)/pi
a1hm <- m1h-b1hm*eulergamma
a1hm
b1hm
#massima verosimiglianza
library("MASS")
fitdistr(data1h,densfun=dgumbel,start=list(loc=a1hm,scale=b1hm)) ->ml1h
ml1h$estimate["loc"] -> a1hv
ml1h$estimate["scale"] -> b1hv
a1hv
b1hv
#minimi quadrati
sort(data1h) -> sorteddata1h
ecdf1h(sorteddata1h)
Y <- -(log(-log(ecdf1h(sorteddata1h))))
Y
Y <- Y[-45]
X <- sorteddata1h[-45]
lm(Y ~ X) ->l01h
b1hq <- 1/l01h$coefficients[2]
a1hq <- - l01h$coefficients[1]*b1hq
a1hq
b1hq
#curve di gumbel
plot(ecdf1h,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 1h")
lines(x,pgumbel(x,loc=a1hm,scale=b1hm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a1hv,scale=b1hv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a1hq,scale=b1hq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a1hm,scale=b1hm) -> qi1hm
c(0,ecdf1h(qi1hm))*length(data1h) -> no11hm
c(ecdf1h(qi1hm),1)*length(data1h) -> no21hm
no21hm-no11hm->no1hm
0.2*length(data1h) -> deltapi1hm
X1hm <- sum((no1hm-deltapi1hm)^2/deltapi1hm)
X1hm
#maxverosimiglianza
qgumbel(q,loc=a1hv,scale=b1hv) -> qi1hv
c(0,ecdf1h(qi1hv))*length(data1h) -> no11hv
c(ecdf1h(qi1hv),1)*length(data1h) -> no21hv
no21hv-no11hv->no1hv
0.2*length(data1h) -> deltapi1hv
X1hv <- sum((no1hv-deltapi1hv)^2/deltapi1hv)
X1hv
#quadrati
qgumbel(q,loc=a1hq,scale=b1hq) -> qi1hq
c(0,ecdf1h(qi1hq))*length(data1h) -> no11hq
c(ecdf1h(qi1hq),1)*length(data1h) -> no21hq
no21hq-no11hq->no1hq
0.2*length(data1h) -> deltapi1hq
X1hq <- sum((no1hq-deltapi1hq)^2/deltapi1hq)
X1hq
#------------------------------------------------------3h-----------------------------------------------------------------
#ecdf
ecdf(data3h) -> ecdf3h
x <- seq(from=0,to=max(data3h),by=1)
ecdf3h(x)
#gumbel
library("evd")
#momenti
mean(data3h)->m3h
var(data3h)->var3h
eulergamma <- 0.5772156649
b3hm <- sqrt(6*var3h)/pi
a3hm <- m3h-b3hm*eulergamma
a3hm
b3hm
#massima verosimiglianza
library("MASS")
fitdistr(data3h,densfun=dgumbel,start=list(loc=a3hm,scale=b3hm)) ->ml3h
ml3h$estimate["loc"] -> a3hv
ml3h$estimate["scale"] -> b3hv
a3hv
b3hv
#minimi quadrati
sort(data3h) -> sorteddata3h
ecdf3h(sorteddata3h)
Y <- -(log(-log(ecdf3h(sorteddata3h))))
Y
Y <- Y[-45]
X <- sorteddata3h[-45]
lm(Y ~ X) ->l03h
b3hq <- 1/l03h$coefficients[2]
a3hq <- - l03h$coefficients[1]*b3hq
a3hq
b3hq
#curve di gumbel
plot(ecdf3h,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 3h")
lines(x,pgumbel(x,loc=a3hm,scale=b3hm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a3hv,scale=b3hv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a3hq,scale=b3hq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a3hm,scale=b3hm) -> qi3hm
c(0,ecdf3h(qi3hm))*length(data3h) -> no13hm
c(ecdf3h(qi3hm),1)*length(data3h) -> no23hm
no23hm-no13hm->no3hm
0.2*length(data3h) -> deltapi3hm
X3hm <- sum((no3hm-deltapi3hm)^2/deltapi3hm)
X3hm
#maxverosimiglianza
qgumbel(q,loc=a3hv,scale=b3hv) -> qi3hv
c(0,ecdf3h(qi3hv))*length(data3h) -> no13hv
c(ecdf1h(qi1hv),1)*length(data1h) -> no23hv
no23hv-no13hv->no3hv
0.2*length(data3h) -> deltapi3hv
X3hv <- sum((no3hv-deltapi3hv)^2/deltapi3hv)
X3hv
#quadrati
qgumbel(q,loc=a3hq,scale=b3hq) -> qi3hq
c(0,ecdf3h(qi3hq))*length(data3h) -> no13hq
c(ecdf3h(qi3hq),1)*length(data3h) -> no23hq
no23hq-no13hq->no3hq
0.2*length(data3h) -> deltapi3hq
X3hq <- sum((no3hq-deltapi3hq)^2/deltapi3hq)
X3hq
#----------------------------------------------------6h-------------------------------------------------------------------
#ecdf
ecdf(data6h) -> ecdf6h
x <- seq(from=0,to=max(data6h),by=1)
ecdf6h(x)
#gumbel
library("evd")
#momenti
mean(data6h)->m6h
var(data6h)->var6h
eulergamma <- 0.5772156649
b6hm <- sqrt(6*var6h)/pi
a6hm <- m6h-b6hm*eulergamma
a6hm
b6hm
#massima verosimiglianza
library("MASS")
fitdistr(data6h,densfun=dgumbel,start=list(loc=a6hm,scale=b6hm)) ->ml6h
ml6h$estimate["loc"] -> a6hv
ml6h$estimate["scale"] -> b6hv
a6hv
b6hv
#minimi quadrati
sort(data6h) -> sorteddata6h
ecdf6h(sorteddata6h)
Y <- -(log(-log(ecdf6h(sorteddata6h))))
Y
Y <- Y[-45]
X <- sorteddata6h[-45]
lm(Y ~ X) ->l06h
b6hq <- 1/l06h$coefficients[2]
a6hq <- - l06h$coefficients[1]*b6hq
a6hq
b6hq
#curve di gumbel
plot(ecdf6h,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 6h")
lines(x,pgumbel(x,loc=a6hm,scale=b6hm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a6hv,scale=b6hv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a6hq,scale=b6hq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a6hm,scale=b6hm) -> qi6hm
c(0,ecdf6h(qi6hm))*length(data6h) -> no16hm
c(ecdf6h(qi6hm),1)*length(data6h) -> no26hm
no26hm-no16hm->no6hm
0.2*length(data6h) -> deltapi6hm
X6hm <- sum((no6hm-deltapi6hm)^2/deltapi6hm)
X6hm
#maxverosimiglianza
qgumbel(q,loc=a6hv,scale=b6hv) -> qi6hv
c(0,ecdf6h(qi6hv))*length(data6h) -> no16hv
c(ecdf6h(qi6hv),1)*length(data6h) -> no26hv
no26hv-no16hv->no6hv
0.2*length(data6h) -> deltapi6hv
X6hv <- sum((no6hv-deltapi6hv)^2/deltapi6hv)
X6hv
#quadrati
qgumbel(q,loc=a6hq,scale=b6hq) -> qi6hq
c(0,ecdf6h(qi6hq))*length(data6h) -> no16hq
c(ecdf6h(qi6hq),1)*length(data6h) -> no26hq
no26hq-no16hq->no6hq
0.2*length(data6h) -> deltapi6hq
X6hq <- sum((no6hq-deltapi6hq)^2/deltapi6hq)
X6hq
#------------------------------------------------------------12h------------------------------------------------------------
#ecdf
ecdf(data12h) -> ecdf12h
x <- seq(from=0,to=max(data12h),by=1)
ecdf12h(x)
#gumbel
library("evd")
#momenti
mean(data12h)->m12h
var(data12h)->var12h
eulergamma <- 0.5772156649
b12hm <- sqrt(6*var12h)/pi
a12hm <- m12h-b12hm*eulergamma
a12hm
b12hm
#massima verosimiglianza
library("MASS")
fitdistr(data12h,densfun=dgumbel,start=list(loc=a12hm,scale=b12hm)) ->ml12h
ml12h$estimate["loc"] -> a12hv
ml12h$estimate["scale"] -> b12hv
a12hv
b12hv
#minimi quadrati
sort(data12h) -> sorteddata12h
ecdf12h(sorteddata12h)
Y <- -(log(-log(ecdf12h(sorteddata12h))))
Y
Y <- Y[-45]
X <- sorteddata12h[-45]
lm(Y ~ X) ->l012h
b12hq <- 1/l012h$coefficients[2]
a12hq <- - l012h$coefficients[1]*b12hq
a12hq
b12hq
#curve di gumbel
plot(ecdf12h,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 12h")
lines(x,pgumbel(x,loc=a12hm,scale=b12hm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a12hv,scale=b12hv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a12hq,scale=b12hq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a12hm,scale=b12hm) -> qi12hm
c(0,ecdf12h(qi12hm))*length(data12h) -> no112hm
c(ecdf12h(qi12hm),1)*length(data12h) -> no212hm
no212hm-no112hm->no12hm
0.2*length(data12h) -> deltapi12hm
X12hm <- sum((no12hm-deltapi12hm)^2/deltapi12hm)
X12hm
#maxverosimiglianza
qgumbel(q,loc=a12hv,scale=b12hv) -> qi12hv
c(0,ecdf12h(qi12hv))*length(data12h) -> no112hv
c(ecdf12h(qi12hv),1)*length(data12h) -> no212hv
no212hv-no112hv->no12hv
0.2*length(data12h) -> deltapi12hv
X12hv <- sum((no12hv-deltapi12hv)^2/deltapi12hv)
X12hv
#quadrati
qgumbel(q,loc=a12hq,scale=b12hq) -> qi12hq
c(0,ecdf12h(qi12hq))*length(data12h) -> no112hq
c(ecdf12h(qi12hq),1)*length(data12h) -> no212hq
no212hq-no112hq->no12hq
0.2*length(data12h) -> deltapi12hq
X12hq <- sum((no12hq-deltapi12hq)^2/deltapi12hq)
X12hq
#----------------------------------------------------------24h------------------------------------------------------------
#ecdf
ecdf(data24h) -> ecdf24h
x <- seq(from=0,to=max(data24h),by=1)
ecdf24h(x)
#gumbel
library("evd")
#momenti
mean(data24h)->m24h
var(data24h)->var24h
eulergamma <- 0.5772156649
b24hm <- sqrt(6*var24h)/pi
a24hm <- m24h-b24hm*eulergamma
a24hm
b24hm
#massima verosimiglianza
library("MASS")
fitdistr(data24h,densfun=dgumbel,start=list(loc=a24hm,scale=b24hm)) ->ml24h
ml24h$estimate["loc"] -> a24hv
ml24h$estimate["scale"] -> b24hv
a24hv
b24hv
#minimi quadrati
sort(data24h) -> sorteddata24h
ecdf24h(sorteddata24h)
Y <- -(log(-log(ecdf24h(sorteddata24h))))
Y
Y <- Y[-45]
X <- sorteddata24h[-45]
lm(Y ~ X) ->l024h
b24hq <- 1/l024h$coefficients[2]
a24hq <- - l024h$coefficients[1]*b24hq
a24hq
b24hq
#curve di gumbel
plot(ecdf24h,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 24h")
lines(x,pgumbel(x,loc=a24hm,scale=b24hm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a24hv,scale=b24hv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a24hq,scale=b24hq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a24hm,scale=b24hm) -> qi24hm
c(0,ecdf24h(qi24hm))*length(data24h) -> no124hm
c(ecdf24h(qi24hm),1)*length(data24h) -> no224hm
no224hm-no124hm->no24hm
0.2*length(data24h) -> deltapi24hm
X24hm <- sum((no24hm-deltapi24hm)^2/deltapi24hm)
X24hm
#maxverosimiglianza
qgumbel(q,loc=a24hv,scale=b24hv) -> qi24hv
c(0,ecdf24h(qi24hv))*length(data24h) -> no124hv
c(ecdf24h(qi24hv),1)*length(data24h) -> no224hv
no224hv-no124hv->no24hv
0.2*length(data24h) -> deltapi24hv
X24hv <- sum((no24hv-deltapi24hv)^2/deltapi24hv)
X24hv
#quadrati
qgumbel(q,loc=a24hq,scale=b24hq) -> qi24hq
c(0,ecdf24h(qi24hq))*length(data24h) -> no124hq
c(ecdf24h(qi24hq),1)*length(data24h) -> no224hq
no224hq-no124hq->no24hq
0.2*length(data24h) -> deltapi24hq
X24hq <- sum((no24hq-deltapi24hq)^2/deltapi24hq)
X24hq
#---------------------------------------------------------15m--------------------------------------------------------------
#ecdf
ecdf(data15m) -> ecdf15m
x <- seq(from=0,to=max(data15m),by=1)
ecdf15m(x)
#gumbel
library("evd")
#momenti
mean(data15m)->m15m
var(data15m)->var15m
eulergamma <- 0.5772156649
b15mm <- sqrt(6*var15m)/pi
a15mm <- m15m-b15mm*eulergamma
a15mm
b15mm
#massima verosimiglianza
library("MASS")
fitdistr(data15m,densfun=dgumbel,start=list(loc=a15mm,scale=b15mm)) ->ml15m
ml15m$estimate["loc"] -> a15mv
ml15m$estimate["scale"] -> b15mv
a15mv
b15mv
#minimi quadrati
sort(data15m) -> sorteddata15m
ecdf15m(sorteddata15m)
Y <- -(log(-log(ecdf15m(sorteddata15m))))
Y
Y <- Y[-30]
X <- sorteddata15m[-30]
lm(Y ~ X) ->l015m
b15mq <- 1/l015m$coefficients[2]
a15mq <- - l015m$coefficients[1]*b15mq
a15mq
b15mq
#curve di gumbel
plot(ecdf15m,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 15m")
lines(x,pgumbel(x,loc=a15mm,scale=b15mm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a15mv,scale=b15mv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a15mq,scale=b15mq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a15mm,scale=b15mm) -> qi15mm
c(0,ecdf15m(qi15mm))*length(data15m) -> no115mm
c(ecdf15m(qi15mm),1)*length(data15m) -> no215mm
no215mm-no115mm->no15mm
0.2*length(data15m) -> deltapi15mm
X15mm <- sum((no15mm-deltapi15mm)^2/deltapi15mm)
X15mm
#maxverosimiglianza
qgumbel(q,loc=a15mv,scale=b15mv) -> qi15mv
c(0,ecdf15m(qi15mv))*length(data15m) -> no115mv
c(ecdf15m(qi15mv),1)*length(data15m) -> no215mv
no215mv-no115mv->no15mv
0.2*length(data15m) -> deltapi15mv
X15mv <- sum((no15mv-deltapi15mv)^2/deltapi15mv)
X15mv
#quadrati
qgumbel(q,loc=a15mq,scale=b15mq) -> qi15mq
c(0,ecdf15m(qi15mq))*length(data15m) -> no115mq
c(ecdf15m(qi15mq),1)*length(data15m) -> no215mq
no215mq-no115mq->no15mq
0.2*length(data15m) -> deltapi15mq
X15mq <- sum((no15mq-deltapi15mq)^2/deltapi15mq)
X15mq
#-------------------------------------------------------30m------------------------------------------------------------
#ecdf
ecdf(data30m) -> ecdf30m
x <- seq(from=0,to=max(data30m),by=1)
ecdf30m(x)
#gumbel
library("evd")
#momenti
mean(data30m)->m30m
var(data30m)->var30m
eulergamma <- 0.5772156649
b30mm <- sqrt(6*var30m)/pi
a30mm <- m30m-b30mm*eulergamma
a30mm
b30mm
#massima verosimiglianza
library("MASS")
fitdistr(data30m,densfun=dgumbel,start=list(loc=a30mm,scale=b30mm)) ->ml30m
ml30m$estimate["loc"] -> a30mv
ml30m$estimate["scale"] -> b30mv
a30mv
b30mv
#minimi quadrati
sort(data30m) -> sorteddata30m
ecdf30m(sorteddata30m)
Y <- -(log(-log(ecdf30m(sorteddata30m))))
Y
Y <- Y[-30]
X <- sorteddata30m[-30]
lm(Y ~ X) ->l030m
b30mq <- 1/l030m$coefficients[2]
a30mq <- - l030m$coefficients[1]*b30mq
a30mq
b30mq
#curve di gumbel
plot(ecdf30m,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 30m")
lines(x,pgumbel(x,loc=a30mm,scale=b30mm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a30mv,scale=b30mv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a30mq,scale=b30mq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a30mm,scale=b30mm) -> qi30mm
c(0,ecdf30m(qi30mm))*length(data30m) -> no130mm
c(ecdf30m(qi30mm),1)*length(data30m) -> no230mm
no230mm-no130mm->no30mm
0.2*length(data30m) -> deltapi30mm
X30mm <- sum((no30mm-deltapi30mm)^2/deltapi30mm)
X30mm
#maxverosimiglianza
qgumbel(q,loc=a30mv,scale=b30mv) -> qi30mv
c(0,ecdf30m(qi30mv))*length(data30m) -> no130mv
c(ecdf30m(qi30mv),1)*length(data30m) -> no230mv
no230mv-no130mv->no30mv
0.2*length(data30m) -> deltapi30mv
X30mv <- sum((no30mv-deltapi30mv)^2/deltapi30mv)
X30mv
#quadrati
qgumbel(q,loc=a30mq,scale=b30mq) -> qi30mq
c(0,ecdf30m(qi30mq))*length(data30m) -> no130mq
c(ecdf30m(qi30mq),1)*length(data30m) -> no230mq
no230mq-no130mq->no30mq
0.2*length(data30m) -> deltapi30mq
X30mq <- sum((no30mq-deltapi30mq)^2/deltapi30mq)
X30mq
#???---------------------------------------------------------45m--------------------------------------------------------------
#ecdf
ecdf(data45m) -> ecdf45m
x <- seq(from=0,to=max(data45m),by=1)
ecdf45m(x)
#gumbel
library("evd")
#momenti
mean(data45m)->m45m
var(data45m)->var45m
eulergamma <- 0.5772156649
b45mm <- sqrt(6*var45m)/pi
a45mm <- m45m-b45mm*eulergamma
a45mm
b45mm
#massima verosimiglianza
library("MASS")
fitdistr(data45m,densfun=dgumbel,start=list(loc=a45mm,scale=b45mm)) ->ml45m
ml45m$estimate["loc"] -> a45mv
ml45m$estimate["scale"] -> b45mv
a45mv
b45mv
#minimi quadrati
sort(data45m) -> sorteddata45m
ecdf45m(sorteddata45m)
Y <- -(log(-log(ecdf45m(sorteddata45m))))
Y
Y <- Y[-27]
X <- sorteddata45m[-27]
lm(Y ~ X) ->l045m
b45mq <- 1/l045m$coefficients[2]
a45mq <- - l045m$coefficients[1]*b45mq
a45mq
b45mq
#curve di gumbel
plot(ecdf45m,xlab="h[mm]",ylab="Fr[H<h]",main="Curve di Gumbel 45m")
lines(x,pgumbel(x,loc=a45mm,scale=b45mm),lwd=2, col="blue")
lines(x,pgumbel(x,loc=a45mv,scale=b45mv),lwd=2, col="red")
lines(x,pgumbel(x,loc=a45mq,scale=b45mq),lwd=2, col="green")
#test di pearson
q <- c(0.2,0.4,0.6,0.8)
#momenti
qgumbel(q,loc=a45mm,scale=b45mm) -> qi45mm
c(0,ecdf45m(qi45mm))*length(data45m) -> no145mm
c(ecdf45m(qi45mm),1)*length(data45m) -> no245mm
no245mm-no145mm->no45mm
0.2*length(data45m) -> deltapi45mm
X45mm <- sum((no45mm-deltapi45mm)^2/deltapi45mm)
X45mm
#maxverosimiglianza
qgumbel(q,loc=a45mv,scale=b45mv) -> qi45mv
c(0,ecdf45m(qi45mv))*length(data45m) -> no145mv
c(ecdf45m(qi45mv),1)*length(data45m) -> no245mv
no245mv-no145mv->no45mv
0.2*length(data45m) -> deltapi45mv
X45mv <- sum((no45mv-deltapi45mv)^2/deltapi45mv)
X45mv
#quadrati
qgumbel(q,loc=a45mq,scale=b45mq) -> qi45mq
c(0,ecdf45m(qi45mq))*length(data45m) -> no145mq
c(ecdf45m(qi45mq),1)*length(data45m) -> no245mq
no245mq-no145mq->no45mq
0.2*length(data45m) -> deltapi45mq
X45mq <- sum((no45mq-deltapi45mq)^2/deltapi45mq)
X45mq
#------------------------------------------------------------------------------------------
#disegno curve di gumbel per le varie durate
a15m <-10.36819
b15m <-3.658615
a30m <-14.29098
b30m <-4.491467
a45m <-15.65286
b45m <-4.07819
a1h <-17.91732
b1h <-4.944069
a3h <-25.43684
b3h <-5.784207
a6h <-33.72082
b6h <-9.888978
a12h <-48.4881
b12h <-13.95235
a24h <-65.29743
b24h <-22.29153
x <- seq(from=1, to=200, by=1)
plot(x,pgumbel(x,a1h,b1h),xlab="Precipitazione [mm]",ylab="Fr[h]", type="l",col="blue", main="Curve di Gumbel")
lines(x,pgumbel(x,a3h,b3h),type="l",col="green")
lines(x,pgumbel(x,a6h,b6h),type="l",col="red")
lines(x,pgumbel(x,a12h,b12h),type="l",col="purple")
lines(x,pgumbel(x,a24h,b24h),type="l",col="orange")
lines(x,pgumbel(x,a15m,b15m),type="l",col="grey")
lines(x,pgumbel(x,a30m,b30m),type="l",col="dark green")
lines(x,pgumbel(x,a45m,b45m),type="l",col="dark red")
#LSPP
d <- c(0.25,0.5,0.75,1,3,6,12,24)
q <- c(1-1/10,1-1/50,1-1/100)
h15m <- c(qgumbel(q,a15m,b15m))
h30m <- c(qgumbel(q,a30m,b30m))
h45m <- c(qgumbel(q,a45m,b45m))
h1 <- c(qgumbel(q,a1h,b1h))
h3 <- c(qgumbel(q,a3h,b3h))
h6 <- c(qgumbel(q,a6h,b6h))
h12 <- c(qgumbel(q,a12h,b12h))
h24 <- c(qgumbel(q,a24h,b24h))
#10 anni
dy <- c(h15m[1],h30m[1],h45m[1],h1[1],h3[1],h6[1],h12[1],h24[1])
lm(log(dy) ~ log(d)) -> lr10
lr10$coefficients[1]
lr10$coefficients[2]
s <- seq(from=1,to=50,by=0.25)
plot(s,exp(lr10$coefficients[1])*s^lr10$coefficients[2],type="l",main="Linee segnalatrici possibilit pluviometrica piano lineare",col="blue",ylim=c(10,300),xlab="t[ore]",ylab="h precipitazione[mm]")
points(d,dy)
#50 anni
cy <- c(h15m[2],h30m[2],h45m[2],h1[2],h3[2],h6[2],h12[2],h24[2])
lm(log(cy) ~ log(d)) -> lr50
lr50$coefficients[1]
lr50$coefficients[2]
lines(s,exp(lr50$coefficients[1])*s^lr50$coefficients[2],type="l",col="green")
points(d,cy)
#100 anni
cey <- c(h15m[3],h30m[3],h45m[3],h1[3],h3[3],h6[3],h12[3],h24[3])
lm(log(cey) ~ log(d)) -> lr100
lr100$coefficients[1]
lr100$coefficients[2]
lines(s,exp(lr100$coefficients[1])*s^lr100$coefficients[2],type="l",col="orange")
points(d,cey)
#log
plot(s,exp(lr10$coefficients[1])*s^lr10$coefficients[2],type="l",main="Linee segnalatrici possibilit pluviometrica piano bilogaritmico",log="xy",col="blue",ylim=c(10,300),xlab="t[ore]",ylab="h precipitazione[mm]")
lines(s,exp(lr50$coefficients[1])*s^lr50$coefficients[2],type="l",col="green")
lines(s,exp(lr100$coefficients[1])*s^lr100$coefficients[2],type="l",col="orange")
points(d,dy)
points(d,cy)
points(d,cey)

